<?php declare(strict_types=1);

namespace Plugin\css_gutschein\Migrations;

use JTL\Plugin\Migration;
use JTL\Update\IMigration;
use JTL\Shop;

class Migration20230302123301 extends Migration implements IMigration {

	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}


	public function up() {

		if(($obj = $this->tableExist('css_gutscheinConfig')) && $obj->Rows > 0) {
			$this->execute("UPDATE css_gutscheinConfig set `version` = '2.5.0' ");
		} else {
			$this->execute(
				"INSERT INTO `css_gutscheinConfig` (`version`) VALUES ('2.5.0')"
			);
		}


		if($this->columnExist('css_gutscheinConfig','shippingVat') === false) {
			$this->execute(
				"
					ALTER TABLE `css_gutscheinConfig` 
					    ADD `shippingVat` INT(4) NOT NULL DEFAULT '0' 
    		");
		}

		if($this->columnExist('css_gutscheinConfig','voucherPost') === false) {
			$this->execute(
				"
					ALTER TABLE `css_gutscheinConfig` 
							ADD `voucherPost` INT(10) NULL DEFAULT '0'
    		");
		}

		if($this->columnExist('css_gutscheinConfig','shippingSurcharge') === false) {
			$this->execute(
				"
					ALTER TABLE `css_gutscheinConfig` 
    					ADD `shippingSurcharge` DECIMAL(5,2) NOT NULL DEFAULT '0' 
    		");
		}


		if($this->columnExist('css_gutscheinConfig','shippingMail') === false) {
			$this->execute(
				"
					ALTER TABLE `css_gutscheinConfig` 
					    ADD `shippingMail` VARCHAR(250) NOT NULL DEFAULT ''
    		");
		}

		if($this->columnExist('css_gutscheinCupon','voucherPost') === false) {
			$this->execute(
				"
					ALTER TABLE `css_gutscheinCupon` 
							ADD `voucherPost` CHAR(1) NULL DEFAULT 'N'
    		");
		}

		if($this->columnExist('css_gutscheinOrder','voucherPost') === false) {
			$this->execute(
				"
					ALTER TABLE `css_gutscheinOrder` 
							ADD `voucherPost` CHAR(1) NULL DEFAULT 'N'
    		");

		}

	}

	/**
	 * @inheritdoc
	 */
	public function down() {
		if ($this->doDeleteData()) {
		}
	}
}
