<?php declare(strict_types=1);

namespace Plugin\css_gutschein\Migrations;

use JTL\Plugin\Migration;
use JTL\Update\IMigration;
use JTL\Shop;

class Migration20231119123301 extends Migration implements IMigration {

	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}


	public function up() {


		if($this->tableExist('css_gutscheinCoupon') == false) {
			$this->execute(
				"
								RENAME TABLE css_gutscheinCupon TO css_gutscheinCoupon;
			");
		}

		if($this->columnExist('css_gutscheinHistory','changes') === false) {
			$this->execute(
				"
					ALTER TABLE `css_gutscheinHistory` 
							ADD `changes` TEXT NOT NULL
    		");
		}

		if($this->columnExist('css_gutscheinHistory','blocked') === false) {
			$this->execute(
				"
					ALTER TABLE `css_gutscheinHistory` 
							ADD `blocked` CHAR(1) NOT NULL DEFAULT 'N'
    		");
		}




		if(($obj = $this->tableExist('css_gutscheinConfig')) && $obj->Rows > 0) {
			$this->execute("UPDATE css_gutscheinConfig set `version` = '2.5.5' ");
		} else {
			$this->execute(
				"INSERT INTO `css_gutscheinConfig` (`version`) VALUES ('2.5.5')"
			);
		}


	}

	/**
	 * @inheritdoc
	 */
	public function down() {
		if ($this->doDeleteData()) {
		}
	}
}
