<?php declare(strict_types=1);

namespace Plugin\css_gutschein\Migrations;

use JTL\Plugin\Migration;
use JTL\Update\IMigration;
use JTL\Shop;

class Migration20243005123302 extends Migration implements IMigration {

	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}


	public function up() {

		if(($obj = $this->tableExist('css_gutscheinConfig')) && $obj->Rows > 0) {
			$this->execute("UPDATE css_gutscheinConfig set `version` = '2.6.3' ");
		} else {
			$this->execute(
				"INSERT INTO `css_gutscheinConfig` (`version`) VALUES ('2.6.3')"
			);
		}


		if($this->columnExist('css_gutscheinConfig','cJson') === false) {
			$cfg = $this->getDB()->query('select * from css_gutscheinConfig where 1',1);
			$rows = [
				'discountType',
				'discount',
				'voucherPost',
				'shippingSurcharge',
				'shippingVat',
				'removeGSPos',
				'kSteuerklasse',
				'optionPrintOrSend',
				'couponCodeForVoucher',
				'freeArticle',
				'cronJob',
				'voucherOrderStatus'
			];
			$cJson = new \stdClass();
			foreach($rows as $key) {
				if(isset($cfg->{$key})) {
					$cJson->{$key} = $cfg->{$key};
					unset($cfg->{$key});
					$this->execute("ALTER TABLE `css_gutscheinConfig` DROP `".$key."`");
				} else {
//					$cJson->{$key} = 0;
				}
			}

			if(empty($cJson->discount)) $cJson->discount = 0;
			if(empty($cJson->discountType)) $cJson->discountType = 'B';
			if(empty($cJson->canUseCoupon)) $cJson->canUseCoupon = 'A';

			$cfg->cJson = json_encode($cJson);
			$this->execute(
				"
					ALTER TABLE `css_gutscheinConfig` ADD `cJson` TEXT NOT NULL
    		");
			$this->getDB()->query("delete from css_gutscheinConfig where 1");
			$this->getDB()->insert("css_gutscheinConfig",$cfg);
		}

	}

	/**
	 * @inheritdoc
	 */
	public function down() {
		if ($this->doDeleteData()) {
		}
	}
}
