<?php

namespace css_gutschein;

use Mpdf\QrCode\QrCode;
use Mpdf\QrCode\Output;

if(!empty($_REQUEST['testmodus'])) {
	error_reporting(E_ALL & ~E_WARNING & ~E_NOTICE & ~E_STRICT & ~E_DEPRECATED & ~E_USER_DEPRECATED);
	ini_set('display_errors', 1);
} else {
	ini_set('display_errors', 0);
	error_reporting(0);
}

require_once(__DIR__ . '/' . 'vendor/autoload.php');

#echo "<pre style='text-align:left; background-color:#ffffff; color:#333333;'>".__FILE__.' / '.__LINE__."<br />".print_r($_POST,true)."</pre>";
#die("File: ".__FILE__."<br>\nFunction: ".__FUNCTION__."<br>\nLine: ".__LINE__."<br>\n");

if(!empty($_POST['createPDF'])) {
	$pdf = new createPDF();
	return $pdf->makePDF();
}

class createPDF {
	public function __construct() {
		return $this;
	}

	public static function localizePrice($price, $currency, $decimals=2,$useHtml=false, $showCurrency=false) {
		$decimalString ='';

		$price = str_replace(",",".",(string) $price);
		if((float) $price == (int) $price) {
			$decimals=0;
		}

		if($decimals == 0 ) {
			$decimalString = $currency->cDecimalSeparator.'-';
		}

		$localized = number_format(
			(float) $price,
			$decimals,
			$currency->cDecimalSeparator,
			$currency->cThousandsSeparator
		);
		if($showCurrency) {
			$currencyName = $useHtml ? $currency->cHtmlEntity : $currency->cName;
		} else {
			$currencyName='';
		}

		return trim ($currency->cForcePlacementBeforeNumber
			? ($currencyName . ' ' . $localized.$decimalString)
			: ($localized .$decimalString . ' ' . $currencyName)
		);

	}


	public function drawText($pos, $imgData, $order, $data,$currency) {

		if(empty($imgData->{'voucher' . $pos . 'Position_top'}) || (int) $imgData->{'voucher' . $pos . 'Position_top'} == -1) return;

		$style ='';
		$percent = 12.2;
		switch ($pos) {
			case 'Top' :
				$classAndFont = 'grusstext-' . $order->voucherImage;
				$output = nl2br($order->voucherText);
				break;
			case 'Middle' :
				$classAndFont = 'wert-' . $order->voucherImage;

				$output = $this->localizePrice($order->voucherPrice,$currency,2,true,($imgData->currency=='N') ? false : true);
				if(!empty($imgData->doubleZero) && $imgData->doubleZero=='N') {
					$output = str_replace(",-", "", $output);
				}

//				$output = str_replace(",-","",$output);
				break;

			case 'Bottom' :
				$classAndFont = 'code-' . $order->voucherImage;
				$output = $data['voucherCode'];
				break;
			case 'Date' :
				$classAndFont = 'date-' . $order->voucherImage;
				$output = $data['voucherDatum'];
				break;

			case 'BarCode':
				$output = '<barcode code="'.$data['voucherCode'].'" height="1" size="12" type="C128B" class="barcode"  />';
				$imgData->{'voucher' . $pos . 'Color'} = 'transparent';
				$imgData->{'voucher' . $pos . 'FontSize'} = 0;
				$classAndFont = 'css-barcode';
				break;
		}

		$imgData->{'voucher' . $pos . 'Position_top'} += (int) $imgData->{'voucher' . $pos . 'Position_top'} / 100 * $percent;
		$imgData->{'voucher' . $pos . 'Position_right'} += (int) $imgData->{'voucher' . $pos . 'Position_right'} / 100 * $percent;
		$imgData->{'voucher' . $pos . 'Position_bottom'} += (int) $imgData->{'voucher' . $pos . 'Position_bottom'} / 100 * $percent;
		$imgData->{'voucher' . $pos . 'Position_left'} += (int) $imgData->{'voucher' . $pos . 'Position_left'} / 100 * $percent;

		$height = ($imgData->{'voucher' . $pos . 'Position_bottom'} - $imgData->{'voucher' . $pos . 'Position_top'});
		$width = ($imgData->{'voucher' . $pos . 'Position_right'} - $imgData->{'voucher' . $pos . 'Position_left'});

		$str = '
			<div class="' . $classAndFont . '" style=" 
			position:absolute;
			top:' . ($imgData->{'voucher' . $pos . 'Position_top'}) . 'px;
			left:' . ($imgData->{'voucher' . $pos . 'Position_left'}) . 'px;
			right:' . ($imgData->{'voucher' . $pos . 'Position_right'}) . 'px;
			width: ' . ($width) . 'px;
			height:' . ($height) . 'px;
			
			'.$style.'
			"><table style=" 
					width:100%;
						font-family: ' . $classAndFont . '; 
						font-size: ' . $imgData->{'voucher' . $pos . 'FontSize'} . 'px;
						"><tr><td style="
									padding:0;
									border:0px solid #c90000;
									width: ' . ($width) . 'px;
									color:' . ($imgData->{'voucher' . $pos . 'Color'}) . ';
									height:' . ($height) . 'px; 
									text-align:' . $imgData->{'voucher' . $pos . 'Align'} . ';
									vertical-align:' . $imgData->{'voucher' . $pos . 'Valign'} . ';
												'.$style.'
">' . $output . '</td></tr></table></div>';


		$this->_mpdf->WriteHtml($str);

	}



	public function makePDF () {
#echo $_POST['createPDF']."\n\n";
		$pdfParameter = unserialize(json_decode($_POST['createPDF']));

		$pdfOptions = $pdfParameter->pdfOptions;
		$imgData = $pdfParameter->imgData;
		$conf = (array) $pdfParameter->conf;
		$testmodus = $pdfParameter->testmodus;
		$currency = $pdfParameter->currency;
		$imageSrc = $pdfParameter->imageSrc;
		$pdfSrc = $pdfParameter->pdfSrc;
		$data = (array) $pdfParameter->data;
		$order = $pdfParameter->order;
		define('PFAD_ROOT', $pdfParameter->PFAD_ROOT);
		define('css_gutschein_VOUCHER_DIR', $pdfParameter->css_gutschein_VOUCHER_DIR);


		$defaultConfig = (new \Mpdf\Config\ConfigVariables ())->getDefaults();
		$fontDirs = $defaultConfig['fontDir'];

		$pdfOptions['fontDir']	= array_merge($fontDirs,$pdfOptions['fontDir']);
		$this->_mpdf = new \Mpdf\Mpdf ($pdfOptions);

#		echo "ende<br>\n";
#		die("File: ".__FILE__."<br>\nFunction: ".__FUNCTION__."<br>\nLine: ".__LINE__."<br>\n");


		$this->_mpdf->simpleTables = true;
		$this->_mpdf->SetTitle('Gutschein von ' . $conf['global']['global_shopname']);
		$this->_mpdf->SetAuthor($conf['global']['global_shopname']);
		$this->_mpdf->SetCreator('CSS-Gutschein created by Andreas Petermann / css-umsetzung.de');

		$this->_mpdf->charset_in = 'UTF-8';

		$this->_mpdf->img_dpi = 96;
		$this->_mpdf->showImageErrors = false;
		$this->_mpdf->debug = false;
		$this->_mpdf->autoScriptToLang = true;

		$this->_mpdf->AddPage();
		$this->_mpdf->Image(PFAD_ROOT . css_gutschein_VOUCHER_DIR . $imgData->voucherImageUrl, 0, 0, 210, 297, 'jpg', '', true, false);

		$this->drawText('Top', $imgData, $order, $data,$currency);
		$this->drawText('Middle', $imgData, $order, $data,$currency);
		$this->drawText('Bottom', $imgData, $order, $data,$currency);
		$this->drawText('Date', $imgData, $order, $data,$currency);
		$this->drawText('BarCode', $imgData, $order, $data,$currency);

		if ($testmodus) {
			$this->_mpdf->Output($pdfSrc, \Mpdf\Output\Destination::INLINE);
			$this->_mpdf->cleanup();
			exit;
		}

		$this->_mpdf->Output($pdfSrc, \Mpdf\Output\Destination::FILE);
		$this->_mpdf->cleanup();

		@unlink($imageSrc);
		echo $order->voucherCode . '.pdf';
		exit;
	}


}
